//==============================================================
// freeze viewer   (STPP.06)
//     for PSP CFW5.00 M33-6
// STEAR 2010-2011
//--------------------------------------------------------------

#ifndef PSP_FREEZEVIEWER_H
#define PSP_FREEZEVIEWER_H

#include <stdio.h>
#include <stdlib.h>
#include <pspiofilemgr.h>
#include "graphics.h"
#include "SMEMO/draw.h"

//----- \ -----

typedef struct {												// bZ[Wp
	int		phase;
	int		error;
	char	msg[6][128];
} iniList;

typedef struct {												// fBNg
	char			*name;
	int				type;										// 0:t@C 1:tH_
	SceOff			size;
	ScePspDateTime	mtime;
	DrawImg			*thumb;										// TlC摜
} FileData;

typedef struct {												// Xg
	int				pos;										// J[\ʒu
	int				count;										// ڐ
	FileData		*file;										// t@C
} DirList;

//----- ̂main.cɂ -----

extern volatile int	gExitRequest;								// [HOME]ɂI`FbN
extern Image		*gScrBuf1, *gScrBuf2;						// wiޔ̈

//----- ϐ -----



#endif
