//==============================================================
// freeze viewer   (STPP.06)
//     for PSP CFW5.00 M33-6
//--------------------------------------------------------------
// ֘A
//--------------------------------------------------------------

#include <stdio.h>
#include <string.h>
#include <malloc.h>
#include <psputils.h>
#include <pspdisplay.h>
#include <pspgu.h>
#include "FreezeViewer.h"
#include "fvDraw.h"
#include "intraFont.h"
#include "charConv.h"

typedef struct {
	unsigned short	u, v;
	short			x, y, z;
} Vertex;


//==============================================================
// ẅ̃Rs[
//--------------------------------------------------------------
// ʏ̎w肳ꂽ̈imageɎ荞ށB
// image͗\ߕKvȑ傫DrawImgCreate()ŊmۂĂĂB
//--------------------------------------------------------------

void BoxCopy2(int x, int y, DrawImg *image)
{
	Color *cor, *dVram = getVramDrawBuffer();
	int	i, j, stepD, stepS;

	if (image){
		sceKernelDcacheWritebackInvalidateAll();				// LbṼCgobN
		cor = image->data;
		dVram += y * PSP_LINE_SIZE + x;
		stepD = image->width - image->wx;
		stepS = PSP_LINE_SIZE - image->wx;
		for (i=0; i<image->wy; i++, cor += stepD, dVram += stepS) {
			for (j=0; j<image->wx; j++, cor++, dVram++) {
				*cor = (*dVram) | 0xFF000000;
			}
		}
//		guStart();
//		sceGuCopyImage( GU_PSM_8888, x, y, image->wx, image->wy, 512, dVram, 0, 0, image->width, image->data );
//		sceGuFinish();
//		sceGuSync( 0, 0 );
	}
}

//==============================================================
// ʃC[WVRAMɑޔ
//--------------------------------------------------------------
// ݂̉ʑŜVRAMɑҔB
//--------------------------------------------------------------

void ScreenCopy2(void)
{
	Color *dVram = getVramDisplayBuffer();

	guStart();
	sceGuCopyImage( GU_PSM_8888, 0, 0, 480, 272, 512, dVram, 0, 272*2.5, 512, VRAM );
	sceGuFinish();
	sceGuSync(0,0);
}

//==============================================================
// ʃC[WVRAM畜A
//--------------------------------------------------------------
// ݂̉ʑŜVRAM畜AB
//--------------------------------------------------------------

void ScreenPaste2(void)
{
	Color *dVram = getVramDrawBuffer();

	guStart();
	sceGuCopyImage( GU_PSM_8888, 0, 272*2.5, 480, 272, 512, VRAM, 0, 0, 512, dVram );
	sceGuFinish();
	sceGuSync(0,0);
}

//==============================================================
// intraFont̕\iUTF8j
//--------------------------------------------------------------
// x,y  :\Jnʒu
// str  :\(UTF8)
// size :tHgTCY
// fCor :tHg̐F
// cCor :e̐F(0:eȂ)
// alpha:ߌW(0.0:`1.0:߂Ȃ)
//--------------------------------------------------------------

int if_print(int x, int y, char *str, float size, Color fCor, Color cCor, float alpha)
{
	int		x2;
	Color	alp;

	if (alpha>1.0f) alpha = 1.0f;
	alp = (Color)(0xFF * alpha) << 24;

	if (cCor) {													// e
		intraFontSetStyle( gJpn0, size, (fCor & 0x00FFFFFF) | alp, (cCor & 0x00FFFFFF) | alp, INTRAFONT_CACHE_ALL );
	} else {													// e
		intraFontSetStyle( gJpn0, size, (fCor & 0x00FFFFFF) | alp, 0, INTRAFONT_CACHE_ALL );
	}
	x2 = intraFontPrint( gJpn0, x, y, str );

	return (x2);
}

//==============================================================
// intraFont̕\iVtgJISj
//--------------------------------------------------------------
// x,y  :\Jnʒu
// str  :\(UTF8)
// size :tHgTCY
// fCor :tHg̐F
// cCor :e̐F(0:eȂ)
// alpha:ߌW(0.0:`1.0:߂Ȃ)
//--------------------------------------------------------------

int if_printSjis(int x, int y,char *str, float size, Color fCor, Color cCor, float alpha)
{
	int		x2;
	char	utf8[512];
	Color	alp;

	if (alpha>1.0f) alpha = 1.0f;
	alp = (Color)(0xFF * alpha) << 24;

	if (cCor) {													// e
		intraFontSetStyle( gJpn0, size, (fCor & 0x00FFFFFF) | alp,(cCor & 0x00FFFFFF) | alp, INTRAFONT_CACHE_ALL );
	} else {													// e
		intraFontSetStyle( gJpn0, size, (fCor & 0x00FFFFFF) | alp, 0, INTRAFONT_CACHE_ALL );
	}
	psp2chSjis2UTF8( utf8, str );
	x2 = intraFontPrint( gJpn0, x, y, utf8 );

	return (x2);
}

//==============================================================
// w肳ꂽŕ؂
//--------------------------------------------------------------
// dst  :o͕iUTF8j
// str  :ɂȂ镶iUTF8j
// width:ڕW̕idotj
// size :tHgTCY
//--------------------------------------------------------------
// strwidthŎw肳ꂽhbgɎ܂悤dstɃRs[B
// strrŐ؂ꍇdst̖ɁucvǉB
//--------------------------------------------------------------

void if_clipText(char *dst, char *str, int width, float size)
{
	char	c[4] = {0,0,0,0};
	float	w, xSize;

	*dst = '\0';
	intraFontSetStyle( gJpn0, size, 0, 0, 0 );
	xSize = intraFontMeasureText( gJpn0, "..." );
	while (*str) {												// 1Â𒲂ׂ
		if ((unsigned char)*str <= 0x7F){						// 1oCgR[hiASCIIj
			c[0] = *(str++);
			c[1] = '\0';
		} else if ((unsigned char)*str <= 0xDFU){				// 2oCgR[h
			c[0] = *(str++);
			c[1] = *(str++);
			c[2] = '\0';
		} else if ((unsigned char)*str <= 0xEFU){				// 3oCgR[h
			c[0] = *(str++);
			c[1] = *(str++);
			c[2] = *(str++);
			c[3] = '\0';
		} else {
			str++;
		}
		w = intraFontMeasureText( gJpn0, c );
		if (xSize+w > width) {
			strcpy( dst, "..." );
			dst += 3;
			break;
		}
		xSize += w;
		*(dst++) = c[0];
		if (c[1]) {
			*(dst++) = c[1];
			if (c[2]) {
				*(dst++) = c[2];
			}
		}
	}
	*dst = '\0';
}

//==============================================================
// {wt̉摜̓ߕ\
//--------------------------------------------------------------
// eNX`TCY32hbgȉɂȂƐɕ\Ȃ炵B
// image_32hbgȉɂȂȂ悤ɂĂ܂B
//--------------------------------------------------------------

#define SLICE_SIZE 32
void DrawPicAlpha(int x, int y, DrawImg *image, float alpha, float scale)
{
	Vertex*	vertices;
	int		i, j;
	int		dy, sw, sh;
	Color	*p;

	sceGuTexMode(GU_PSM_8888, 0, 0, GU_FALSE);
	sceGuTexFunc(GU_TFX_MODULATE, GU_TCC_RGBA);
	sceGuTexFilter(GU_LINEAR, GU_LINEAR);
	sceGuColor(GU_RGBA(0xFF, 0xFF, 0xFF, (int)(alpha * 255.0f)));

	p = image->data;
	sw = image->width;
	sh = image->height;
	dy = 32 * scale;
	i = 0;
	while (sh > 32)
	{
		for (j = 0; (j + SLICE_SIZE) < sw; j = j + SLICE_SIZE)
		{
			sceGuTexImage(0, image->width, image->height, image->width, p + j);
			vertices = (Vertex*)sceGuGetMemory(2 * sizeof(Vertex));
			vertices[0].u = 0;
			vertices[0].v = 0;
			vertices[0].x = x + j * scale;
			vertices[0].y = y + dy * i;
			vertices[1].u = SLICE_SIZE;
			vertices[1].v = 32;
			vertices[1].x = x + (j + SLICE_SIZE) * scale;
			vertices[1].y = y + dy * (i + 1);
			sceGuDrawArray(GU_SPRITES, GU_TEXTURE_16BIT | GU_VERTEX_16BIT | GU_TRANSFORM_2D, 2, NULL, vertices);
		}
		if (j < sw)
		{
			sceGuTexImage(0, image->width, image->height, image->width, p + j);
			vertices = (Vertex*)sceGuGetMemory(2 * sizeof(Vertex));
			vertices[0].u = 0;
			vertices[0].v = 0;
			vertices[0].x = x + j * scale;
			vertices[0].y = y + dy * i;
			vertices[1].u = sw - j;
			vertices[1].v = 32;
			vertices[1].x = x + sw * scale;
			vertices[1].y = y + dy * (i + 1);
			sceGuDrawArray(GU_SPRITES, GU_TEXTURE_16BIT | GU_VERTEX_16BIT | GU_TRANSFORM_2D, 2, NULL, vertices);
		}
		sh -= 32;
		y += 32 * scale;
		p += image->width * 32;
		i++;
	}
	for (j = 0; (j + SLICE_SIZE) < sw; j = j + SLICE_SIZE)
	{
		sceGuTexImage(0, image->width, image->height, image->width, p + j);
		vertices = (Vertex*)sceGuGetMemory(2 * sizeof(Vertex));
		vertices[0].u = 0;
		vertices[0].v = 0;
		vertices[0].x = x + j * scale;
		vertices[0].y = y;
		vertices[0].z = 0;
		vertices[1].u = SLICE_SIZE;
		vertices[1].v = sh;
		vertices[1].x = x + (j + SLICE_SIZE) * scale;
		vertices[1].y = y + sh * scale;
		vertices[1].z = 0;
		sceGuDrawArray(GU_SPRITES, GU_TEXTURE_16BIT | GU_VERTEX_16BIT | GU_TRANSFORM_2D, 2, NULL, vertices);
	}
	if (j < sw)
	{
		sceGuTexImage(0, image->width, image->height, image->width, p + j);
		vertices = (Vertex*)sceGuGetMemory(2 * sizeof(Vertex));
		vertices[0].u = 0;
		vertices[0].v = 0;
		vertices[0].x = x + j * scale;
		vertices[0].y = y;
		vertices[0].z = 0;
		vertices[1].u = sw - j;
		vertices[1].v = sh;
		vertices[1].x = x + sw * scale;
		vertices[1].y = y + sh * scale;
		vertices[1].z = 0;
		sceGuDrawArray(GU_SPRITES, GU_TEXTURE_16BIT | GU_VERTEX_16BIT | GU_TRANSFORM_2D, 2, NULL, vertices);
	}
}


